#include <bits/stdc++.h>

using namespace std;

int n,m;
vector<int> v[100010];
int in[100010];
int out[100010];
int used[100010];
vector<int> ans;

int bfs(int x,int k){
    used[x]=1;
    for(int i=0; i<v[x].size(); i++){
        if(v[x][i]==1 && k==n){
            ans.push_back(x);
            return 1;
        }
        if(used[v[x][i]]==0){
            if(bfs(v[x][i],k+1)==1){
                ans.push_back(x);
                return 1;
            }

        }
    }
    used[x]=0;
    return 0;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    cin>>n>>m;
    for(int i=0; i<m; i++){
        int x,y;
        cin>>x>>y;
        v[x].push_back(y);
        in[y]++;
        out[x]++;
    }
    bfs(1,1);
    for(int i=1; i<=n; i++)
        if(used[i]==0){
            cout<<"NO"<<endl;
            return 0;
        }
    cout<<"YES"<<endl;
    for(int i=ans.size()-1; i>=0; i--)
        cout<<ans[i]<<' ';
    cout<<ans[ans.size()-1];
    return 0;
}